#
# spec file for package apparmor-parser (Version 2.0)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcap libcap-devel libcom_err libgcc libnscd libstdc++ libtool libxcrypt libzio m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel

Name:           apparmor-parser
%if ! %{?distro:1}0
  %define distro suse
%endif
Summary:        AppArmor userlevel parser utility
Version:        2.0
Release:        21.4
Group:          Productivity/Networking/Security
Source0:        %{name}-%{version}-6358.tar.gz
Patch0:         apparmor-parser-aaeventd_description_fixup-r52-172961.patch
Patch1:         apparmor-parser-fix_segv_nonexistant_dir-r30-160330.patch
Patch2:         apparmor-parser-m_flag-code10-175388.patch
Patch3:         apparmor-parser-add_PxUx-code10-172061.patch
License:        GPL, Other License(s), see package
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
URL:            http://forge.novell.com/modules/xfmod/project/?apparmor
Prereq:         sed
%if %{distro} == "suse"
Prereq:         %{insserv_prereq} aaa_base
%endif
%if %{distro} == "rhel4"
Prereq:         apparmor-master
%endif
%if %{suse_version}%{!?suse_version:1} > 1000
BuildRequires:  libcap-devel
%else
BuildRequires:  libcap
%endif
Obsoletes:      subdomain_parser subdomain-parser
Obsoletes:      subdomain-parser-demo subdomain-parser-common subdomain-leaf-cert
Obsoletes:      libimnxcert
Provides:       subdomain_parser subdomain-parser
Provides:       subdomain-parser-demo subdomain-parser-common subdomain-leaf-cert
Provides:       libimnxcert
%define apparmor_bin_prefix /lib/apparmor

%description 
The AppArmor Parser is a userlevel program that is used to load in
program profiles to the AppArmor Security kernel module.

This package is part of a suite of tools that used to be named
SubDomain.



Authors:
--------
    jjohansen@suse.de
    sbeattie@suse.de
    tonyj@suse.de

%debug_package
%prep
%setup -q
%patch0 -p3
%patch1 -p3
%patch2 -p3
%patch3 -p3

%build
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf $RPM_BUILD_ROOT
make clean all CFLAGS="${RPM_OPT_FLAGS}"

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install DESTDIR=${RPM_BUILD_ROOT} \
	     DISTRO=%{distro} \
	     APPARMOR_BIN_PREFIX=${RPM_BUILD_ROOT}%{apparmor_bin_prefix}
strip ${RPM_BUILD_ROOT}/sbin/apparmor_parser

%clean 
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf $RPM_BUILD_ROOT

%files 
%defattr(-,root,root)
%doc README COPYING.GPL
/sbin/apparmor_parser
%dir %attr(-, root, root) /etc/apparmor
%if %{distro} == "suse"
  /sbin/rcsubdomain
  /sbin/rcapparmor
  /etc/init.d/boot.apparmor
  /sbin/rcaaeventd
  /etc/init.d/aaeventd
%else
  /etc/init.d/apparmor
  /etc/init.d/aaeventd
%endif
%config(noreplace) /etc/apparmor/subdomain.conf
/subdomain
/var/lib/apparmor
%dir %attr(-, root, root) %{apparmor_bin_prefix}
%{apparmor_bin_prefix}/rc.apparmor.functions
%{_prefix}/share/locale/*/*/apparmor-parser.mo
# XXX Grumble autobuild grumble
%dir %attr(-,root,root) /usr/share/locale/hu_HU
%dir %attr(-,root,root) /usr/share/locale/hu_HU/LC_MESSAGES
%dir %attr(-,root,root) /usr/share/locale/ja_JP
%dir %attr(-,root,root) /usr/share/locale/ja_JP/LC_MESSAGES

%pre
%if %{distro} == "redhat" || %{distro} == "rhel4"
if [ -f /etc/init.d/subdomain ] ; then
  chkconfig --del subdomain
fi
%endif

%post
%if %{distro} == "suse"
  # SUSE uses insserv
  # For package renaming from subdomain -> apparmor
  # we check the existence of the AppArmor 1.1 and 
  # AppArmor 1.2 based init script to help determine 
  # whether  we are upgrading
  SUBDOMAIN_PARSER_INSTALLED="no"
  if test -e /etc/init.d/boot.subdomain -o -e /etc/init.d/subdomain; then
    SUBDOMAIN_PARSER_INSTALLED="yes"
  fi
  if  test "$1" == 1  -a $SUBDOMAIN_PARSER_INSTALLED = "no"; then    
    %{insserv_force_if_yast boot.apparmor}
  elif test -e /etc/rc.d/boot.d/S??boot.subdomain  -o \
            -e /etc/rc.d/boot.d/S??boot.apparmor  -o \
            -e /etc/rc.d/rc3.d/S??subdomain ; then
    %{insserv_force_if_yast boot.apparmor}
  else    
    %{fillup_and_insserv -f boot.apparmor}  
  fi
%endif
%if %{distro} == "redhat" || %{distro} == "rhel4"
  chkconfig --add apparmor
%endif
%if %{distro} == "slackware"
  if grep -qs "# BEGIN rc.subdomain INSERTION" /etc/rc.d/rc.M ; then true ; else
    %{apparmor_bin_prefix}/install/frob_slack_rc --init
  fi
  if grep -qs "# BEGIN rc.subdomain INSERTION" /etc/rc.d/rc.K ; then true ; else
    %{apparmor_bin_prefix}/install/frob_slack_rc --shutdown
  fi
%endif
if [ %{?suse_version}%{!?suse_version:1} -le 1000 ] ; then
  SFS_MOUNTPOINT=$(grep subdomainfs /etc/fstab  | \
                 sed -e 's|^[[:space:]]*[^[:space:]]+[[:space:]]\+\(/[^[:space:]]*\)[[:space:]]\+subdomainfs.*$|\1|' 2> /dev/null)
  if [ "X" == "X${SFS_MOUNTPOINT}" ]; then
    echo "subdomain            /subdomain       subdomainfs noauto         0 0" >> /etc/fstab
  fi
fi

%preun
if [ "$1" = 0 ] ; then
%if %{distro} == "suse"
  /sbin/insserv -r boot.apparmor
%endif
%if %{distro} == "redhat" || %{distro} == "rhel4"
  chkconfig --del apparmor
%endif
fi

%postun
%if %{distro} == "suse"
  %{insserv_cleanup}
%endif

%changelog -n apparmor-parser
* Wed May 31 2006 - sbeattie@suse.de
- Add support for 'm' flag (mmap w/PROT_EXEC permission) (#175388)
- Add Px and Ux flags to indicate to ld.so that sensitive environemnt
  variables should be filtered on exec() (#172061) The m, Px, and Ux
  flags are added in such a way that apparmor modules without
  corresponding support will just ignore them.
- Fix segv if profiles directory does not exist (#160330)
- Fix aaeventd initscript description (#172961)
* Mon Apr 03 2006 - dreynolds@suse.de
- Fix upgrade problems from sles9/sl10.0 (#156990)
* Mon Mar 27 2006 - jmichael@suse.de
- Split aaeventd startup into its own init script so we don't start
  daemons while in the "boot" runlevel (#158613)
- Obsoleted libimnxcert (#157450)
* Mon Feb 13 2006 - dreynolds@suse.de
- sbeattie@suse.de changes...
- Filter multiple slashes and trailing slashes in pathnames
- Use RPM_OPT_FLAGS
- A few s/SubDomain/AppArmor/ fixups in error messages
* Mon Feb 06 2006 - sbeattie@suse.de
- Fix one last issue in initscript handling of whitespace (#141288)
- Add libcap-devel dependency for newer SUSE distros
- Fix shutting down aa-eventd
- Add option to enable/disable aa-eventd (#145465)
- Disable owlsm warning if module doesn't support it (#146470)
* Sun Jan 29 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Sun Jan 29 2006 - sbeattie@suse.de
- s/none/securityfs/ in the initscript (#143372)
- add support for if {} else if {}
- rename initscript to rc.apparmor
- support /etc/apparmor.d
- add buildrequires on libcap-devel
- (dreynolds) Updated rc.subdomain.functions to reference newly named event daemon aa-eventd
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 23 2006 - sbeattie@suse.de
- convert to insserv macros, reenable apparmor by default (#143372)
- add prereq on aaa_base (#143372)
- remove initscript dependency on boot.ldconfig
- Don't edit fstab on newer suse releases (#143402)
- Add build dependency on libcap-devel
* Tue Jan 17 2006 - dreynolds@suse.de
- Removed calls to inssrv to prevent the boot.subdomain service from being enabled by default.
* Sat Jan 14 2006 - sbeattie@suse.de
- Add support for giving a filename on the parser command line
- Some refactoring of code in prep for variable support.
- Add svn repo to tarball
- Rename service provided by initscript to apparmor
- Initial set variable support
- Restructure global policy list
- Fix leaks found by valgrind
- Restructure hats within profiles, detect duplicate hats
- Add basic conditional statement support
- Fix debug mode to not attempt to load policy
- Add svn repo number to tarball name
* Fri Dec 09 2005 - sbeattie@suse.de
-  Fix references to old package name in .po files
* Thu Dec 08 2005 - sbeattie@suse.de
- rename subdomain-parser package to apparmor-parser
- Relicense package to GPL for open source release
- Reset version to 2.0-1
- add support for securityfs in initscript and parser
